import { getExtensions } from '../constants';

var YES = 'yes';
var NO = 'no';
var PASS = true;

var onetoone = function onetoone(a) {
    return a;
};
var pass = function pass() {
    return PASS;
};
var empty = function empty() {
    return null;
};

var createPlugin = function createPlugin(plugin) {
    var result = Object.assign({
        init: empty,
        fileNameTransformer: onetoone,
        wipeCheck: pass,
        shouldMock: pass
    }, plugin);
    return result;
};

var standardWipeCheck = function standardWipeCheck(stubs, moduleName) {
    if (getExtensions().some(function (ext) {
        return stubs[moduleName + ext];
    })) {
        return YES;
    }
};

export { standardWipeCheck, YES, NO, PASS };

export default createPlugin;